@rem = '--*-Perl-*--
@echo off
.\bin\perl -w uninstall.bat %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
@rem ';
#!perl -w
#################################################################
#
#   script to set up path and shortcuts to the Perl installation
#   run this bat file from the directory where perl is installed
#
#################################################################

@rem = (); # eliminate warning

use Config;
use Win32::API;
use Win32::Shortcut;
use Win32::Registry;
use strict;
use DSUtil;


my $shortcutfoldername = "IndigoPerl";

my $configUser = 0;  # set up user path and shortcuts instead of shared ones
my ($key);
if ($configUser || Win32::IsWin95()) {
    $key = 'HKCU\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Programs';
} else {
    $key = 'HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Common Programs';
}

my $foldername = DS::GetReg($key);
if (-d "$foldername\\$shortcutfoldername") {
    print "Removing shortcut folder $foldername\\$shortcutfoldername\n";
    RemoveShortcuts("$foldername\\$shortcutfoldername");
    rmdir "$foldername\\$shortcutfoldername";
} else {
    print "Shortcut folder $foldername\\$shortcutfoldername does not exist\n";
}



# update path
my $path = $ENV{'PATH'};
my $escaped_path;
($escaped_path = $Config{'binexp'}) =~ s/\\/\\\\/g;
if ($path !~ m/^$escaped_path/i) {
    print "No change to path required\n";
}
else {
    print "Removing $Config{'binexp'} from path\n";
    if(Win32::IsWinNT()) {
        my $key;
        if ($configUser) {
            $key = 'HKCU\Environment\path';
        } else {
            $key = 'HKLM\SYSTEM\CurrentControlSet\Control\Session Manager\Environment\path';
        }
        $path = DS::GetReg($key);
        $path =~ s/^$escaped_path;//;   # todo this will only remove path if it is at start of path
        DS::SetReg($key, "$path");
        my $SendMessageTimeout = new Win32::API("user32", "SendMessageTimeout", 
                ['N','N','N','P','N','N','P'], 'N');
        my $dwResult = pack("L", 0);
        $SendMessageTimeout->Call(0xffff, 0x001A, 0, "Environment", 0x0002, 5000,$dwResult);
    }
    else {
        print "Updating c:\\autoexec.bat\n";
        my $data = DS::ReadFile("C:/autoexec.bat");
        my ($pp) = "PATH=";

        $data =~ s/(.*)(^|\n)(set\s+|)(\s*path\s*=\s*)(.*?)(\n|$)/$1$2$3$pp$5$6/is;
	$path = $5;
        $path =~ s/^$escaped_path;//i;
        $data =~ s/(.*)(^|\n)(set\s+|)(\s*path\s*=\s*)(.*?)(\n|$)/$1$2$3$pp$path$6/is;
        DS::WriteFile("c:\\autoexec.bat", $data);

        print "Updating master environment block:\n$path\n";
        $path = $ENV{'PATH'};
        $path =~ s/^$escaped_path;//i;
        system("$Config{'binexp'}\\winset PATH=$path");
    }
    print "\n\nYour path has been modified\n";
    print "The new path will take effect when any new window is opened\n";
}





sub RemoveShortcuts
{
    my ($folder) = @_;
    unlink ("$folder\\PerlConsole.lnk",
            "$folder\\PerlDocumentation.lnk",
            "$folder\\Start Apache.lnk",
            "$folder\\Stop Apache.lnk",
            "$folder\\View website.lnk");
}


__END__
:endofperl

